package com.logicbig.example;

import javax.persistence.*;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Entity
public class Employee {
    @Id
    @GeneratedValue
    private long id;
    private String name;
    @OneToMany
    @JoinTable(name = "ASSIGNED_TASKS",
            joinColumns = {@JoinColumn(name = "EMPLOYEE_FK")},
            inverseJoinColumns = {@JoinColumn(name = "TASK_FK")})
    @MapKeyColumn(name = "TASK_DATE")
    private Map<Date, Task> tasks;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Map<Date, Task> getTasks() {
        return tasks;
    }

    public void setTasks(Map<Date, Task> tasks) {
        this.tasks = tasks;
    }

    public void addTask(Date taskDate, Task task) {
        if (tasks == null) {
            tasks = new HashMap<>();
        }
        tasks.put(taskDate, task);
    }

    @Override
    public String toString() {
        return "Employee{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", tasks=" + tasks +
                '}';
    }
}